﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using Primitives3D;

namespace Lab6
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        BasicEffect effect;

        TeapotPrimitive teapot;
        CylinderPrimitive cylinder;
        CubePrimitive cube;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            effect = new BasicEffect(GraphicsDevice, null);

            cube = new CubePrimitive(GraphicsDevice);
            cylinder = new CylinderPrimitive(GraphicsDevice);
            teapot = new TeapotPrimitive(GraphicsDevice);

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
            Matrix world = Matrix.CreateRotationY((float)gameTime.TotalGameTime.TotalSeconds);
            Matrix view = Matrix.CreateLookAt(new Vector3(0, 1, 5), Vector3.Zero, Vector3.Up);
            Matrix proj = Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45), GraphicsDevice.Viewport.AspectRatio, 0.1f, 10);

            effect.View = view;
            effect.Projection = proj;

            effect.LightingEnabled = true;
            effect.SpecularColor = new Vector3(1, 1, 1);
            effect.SpecularPower = 24;

            effect.AmbientLightColor = new Vector3(0.2f, 0.2f, 0.2f);
            
            // Задание параметров первого источника света
            effect.DirectionalLight0.Enabled = true;
            effect.DirectionalLight0.Direction = new Vector3(1, 0, 0);
            effect.DirectionalLight0.DiffuseColor = new Vector3(0.5f, 0, 0);
            effect.DirectionalLight0.SpecularColor = new Vector3(1, 0, 0);

            // Задание параметров второго источника света
            effect.DirectionalLight1.Enabled = true;
            effect.DirectionalLight1.Direction = new Vector3(-1, 0, 0);
            effect.DirectionalLight1.DiffuseColor = new Vector3(0, 0, 0.5f);
            effect.DirectionalLight1.SpecularColor = new Vector3(0, 0, 1);
            
            // Включение попиксельного освещения
            effect.PreferPerPixelLighting = true;

            effect.World = world;
            effect.DiffuseColor = new Vector3(1, 0, 0);
            cube.Draw(effect);

            effect.World = world * Matrix.CreateTranslation(2, 0, 0);
            effect.DiffuseColor = new Vector3(0, 1, 0);
            cylinder.Draw(effect);

            effect.World = world * Matrix.CreateTranslation(-2, 0, 0);
            effect.DiffuseColor = new Vector3(0, 0, 1);
            teapot.Draw(effect);

            base.Draw(gameTime);
        }
    }
}
